local BHS = CreateFrame("Frame", nil, UIParent)
Broker_CasterStatsDB = {
	hastemode = false,
	critmode = false,
	hitmode = false,
}
local db = Broker_CasterStatsDB
---
BHS.Regen = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_ManaRegen", {
	label = "Manaregen", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Magic_ManaGain",
	value = "0",
	suffix = "0",
	OnTooltipShow = function(regentooltip)
	if not regentooltip or not regentooltip.AddLine then return end
    regentooltip:AddLine( BHS.Regen.tooltiptext )
	end,	
})
BHS.Power = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellPower", {
	label = "Spellpower", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Shadow_TwistedFaith",
	value = "0",
	suffix = " pts",
	OnTooltipShow = function(powertooltip)
	if not powertooltip or not powertooltip.AddLine then return end
    powertooltip:AddLine("Spellpower")
    powertooltip:AddDoubleLine("Holy:", format("%s%s", BHS.Power.Holy, " pts"))
    powertooltip:AddDoubleLine("Fire:", format("%s%s", BHS.Power.Fire, " pts"))
    powertooltip:AddDoubleLine("Nature:", format("%s%s", BHS.Power.Nature, " pts"))
    powertooltip:AddDoubleLine("Frost:", format("%s%s", BHS.Power.Frost, " pts"))
    powertooltip:AddDoubleLine("Shadow:", format("%s%s", BHS.Power.Shadow, " pts"))
    powertooltip:AddDoubleLine("Arcane:", format("%s%s", BHS.Power.Arcane, " pts"))
	end,	
})
BHS.Crit = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellCrit", {
	label = "Spellcrit", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Shadow_Teleport",
	value = "0",
	suffix = "0",
	OnTooltipShow = function(crittooltip)
	if not crittooltip or not crittooltip.AddLine then return end
    crittooltip:AddLine("Spellcrit")
    crittooltip:AddDoubleLine("Rating:", format("|cffeeeeee%.0f%s|r", GetCombatRating(11), " pts"))
    crittooltip:AddDoubleLine("Holy:", format("|cffeeeeee%s%s|r", BHS.Crit.Holy, " %"))
    crittooltip:AddDoubleLine("Fire:", format("|cffeeeeee%s%s|r", BHS.Crit.Fire, " %"))
    crittooltip:AddDoubleLine("Nature:", format("|cffeeeeee%s%s|r", BHS.Crit.Nature, " %"))
    crittooltip:AddDoubleLine("Frost:", format("|cffeeeeee%s%s|r", BHS.Crit.Frost, " %"))
    crittooltip:AddDoubleLine("Shadow:", format("|cffeeeeee%s%s|r", BHS.Crit.Shadow, " %"))
    crittooltip:AddDoubleLine("Arcane:", format("|cffeeeeee%s%s|r", BHS.Crit.Arcane, " %"))
	crittooltip:AddLine("Click to toggle")
	end,	
	OnClick = function(self, btn)
		db.critmode = not db.critmode
		BHS:OnEvent()
	end,	
})
BHS.Haste = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellHaste", {
	label = "Spellhaste", 
	type = "data source", 
	icon = "Interface\\Icons\\Ability_Rogue_Sprint",
	value = "0",
	suffix = "0",
	OnClick = function(self, btn)
		db.hastemode = not db.hastemode
		BHS:OnEvent()
	end,
	OnTooltipShow = function(hastetooltip)
	if not hastetooltip or not hastetooltip.AddLine then return end
    hastetooltip:AddLine("Spellhaste")
    hastetooltip:AddDoubleLine("Rating:", format("|cffeeeeee%.0f%s|r", GetCombatRating(20), " pts"))
    hastetooltip:AddDoubleLine("Bonus:", format("|cffeeeeee%.2f%s|r", GetCombatRatingBonus(20), " %"))
	hastetooltip:AddLine("Click to toggle")
	end,	

})
BHS.Hit = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellHit", {
	label = "Spellhit", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Shadow_ShadowEmbrace",
	value = "0",
	suffix = "0",
	OnClick = function(self, btn)
		db.hitmode = not db.hitmode
		BHS:OnEvent()
	end,
	OnTooltipShow = function(hittooltip)
	if not hittooltip or not hittooltip.AddLine then return end
    hittooltip:AddLine("Spellhit")
    hittooltip:AddDoubleLine("Rating:", format("|cffeeeeee%.0f%s|r", GetCombatRating(8), " pts"))
    hittooltip:AddDoubleLine("Bonus:", format("|cffeeeeee%.2f%s|r", GetCombatRatingBonus(8), " %"))
	hittooltip:AddLine("Click to toggle")
	end,	
})
---

BHS.UpdateInterval = 0.2
BHS.missing_mana = UnitManaMax"player" - UnitMana"player"
BHS.time_in_fsr = 0

---

function BHS:Update()
--- Regen
	local out_of_fsr, in_fsr = GetManaRegen()
	self.Regen.suffix = " mp5"
    if self.time_in_fsr > 4 then
        self.Regen.value = format("%s %d", ".....", in_fsr * 5)
        self.Regen.text = format("%s %d", ".....", in_fsr * 5)
    elseif self.time_in_fsr > 3 then
       	self.Regen.value = format("%s %d", " ....", in_fsr * 5)
       	self.Regen.text = format("%s %d", " ....", in_fsr * 5)
    elseif self.time_in_fsr > 2 then
        self.Regen.value = format("%s %d", "  ...", in_fsr * 5)
        self.Regen.text = format("%s %d", "  ...", in_fsr * 5)
    elseif self.time_in_fsr > 1 then
        self.Regen.value = format("%s %d", "   ..", in_fsr * 5)
        self.Regen.text = format("%s %d", "   ..", in_fsr * 5)
    elseif self.time_in_fsr > 0 then
        self.Regen.value = format("%s %d", "    .", in_fsr * 5)
        self.Regen.text = format("%s %d", "    .", in_fsr * 5)
    else
        self.Regen.value = format("%d", out_of_fsr * 5)
        self.Regen.text = format("%d", out_of_fsr * 5)
    end
---
end


function BHS:OnEvent(event)
--- Regen
	local new_missing_mana = UnitManaMax"player" - UnitMana"player"
	if new_missing_mana > self.missing_mana then
	    self.time_in_fsr = 5
	end
	self.missing_mana = new_missing_mana
--- Regen Tooltip
	local out_of_fsr, in_fsr = GetManaRegen()
    	self.Regen.tooltiptext = format ("%d %s %d %s", in_fsr * 5, " / ", out_of_fsr * 5, "mp5")

--- Power
    local power = GetSpellBonusDamage(1)
	if (GetSpellBonusDamage(2) > power) then power = GetSpellBonusDamage(2) end
	if (GetSpellBonusDamage(3) > power) then power = GetSpellBonusDamage(3) end
	if (GetSpellBonusDamage(4) > power) then power = GetSpellBonusDamage(4) end
	if (GetSpellBonusDamage(5) > power) then power = GetSpellBonusDamage(5) end
	if (GetSpellBonusDamage(6) > power) then power = GetSpellBonusDamage(6) end
	if (GetSpellBonusDamage(7) > power) then power = GetSpellBonusDamage(7) end
		self.Power.value = power
		self.Power.text = power
		self.Power.Holy = GetSpellBonusDamage(2)
		self.Power.Fire = GetSpellBonusDamage(3)
		self.Power.Nature = GetSpellBonusDamage(4)
		self.Power.Frost = GetSpellBonusDamage(5)
		self.Power.Shadow = GetSpellBonusDamage(6)
		self.Power.Arcane = GetSpellBonusDamage(7)

--- Crit
	local crit = GetSpellCritChance(1)
	if (GetSpellCritChance(2) > crit) then crit = GetSpellCritChance(2) end
	if (GetSpellCritChance(3) > crit) then crit = GetSpellCritChance(3) end
	if (GetSpellCritChance(4) > crit) then crit = GetSpellCritChance(4) end
	if (GetSpellCritChance(5) > crit) then crit = GetSpellCritChance(5) end
	if (GetSpellCritChance(6) > crit) then crit = GetSpellCritChance(6) end
	if (GetSpellCritChance(7) > crit) then crit = GetSpellCritChance(7) end
	local critbonus = format("%.2f", crit)
	local critbonussuffix = " %"
	local critrating = format("%.0f", GetCombatRating(11))
	local critratingsuffix = " pts"
		self.Crit.value = db.critmode and critrating or critbonus
		self.Crit.text = db.critmode and critrating or critbonus
		self.Crit.suffix = db.critmode and critratingsuffix or critbonussuffix
		self.Crit.Holy = format ("%.2f", GetSpellCritChance(2))
		self.Crit.Fire = format ("%.2f", GetSpellCritChance(3))
		self.Crit.Nature = format ("%.2f", GetSpellCritChance(4))
		self.Crit.Frost = format ("%.2f", GetSpellCritChance(5))
		self.Crit.Shadow = format ("%.2f", GetSpellCritChance(6))
		self.Crit.Arcane = format ("%.2f", GetSpellCritChance(7))

--- Haste	
	local hasterating = format("%.0f", GetCombatRating(20))
	local hasteratingsuffix = " pts"
	local hastebonus = format("%.2f", GetCombatRatingBonus(20))
	local hastebonussuffix = " %"
		self.Haste.value = db.hastemode and hasterating or hastebonus
		self.Haste.text = db.hastemode and hasterating or hastebonus
		self.Haste.suffix = db.hastemode and hasteratingsuffix or hastebonussuffix
--- Hit	
	local hitrating = format("%.0f", GetCombatRating(8))
	local hitratingsuffix = " pts"
	local hitbonus = format("%.2f", GetCombatRatingBonus(8))
	local hitbonussuffix = " %"
		self.Hit.value = db.hitmode and hitrating or hitbonus
		self.Hit.text = db.hitmode and hitrating or hitbonus
		self.Hit.suffix = db.hitmode and hitratingsuffix or hitbonussuffix
---
		self:Update()
end


function BHS:OnUpdate(elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate or 0
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
    local time_in_fsr = self.time_in_fsr or 0
    local new_time_in_fsr = time_in_fsr - elapsed
    self.time_in_fsr = new_time_in_fsr
    if (self.TimeSinceLastUpdate > BHS.UpdateInterval) then
    self:Update()
    self.TimeSinceLastUpdate = 0
  	end
end

---
BHS:SetScript("OnEvent", BHS.OnEvent)
BHS:SetScript("OnUpdate", BHS.OnUpdate)

BHS:RegisterEvent("PLAYER_ENTERING_WORLD")
BHS:RegisterEvent("UNIT_MANA")
BHS:RegisterEvent("COMBAT_RATING_UPDATE")
BHS:RegisterEvent("PLAYER_AURAS_CHANGED")

--EOF